--- old/usr/src/uts/common/fs/tmpfs/tmp_subr.c	Wed Oct  5 00:33:44 2016
+++ new/usr/src/uts/common/fs/tmpfs/tmp_subr.c	Wed Oct  5 00:33:44 2016
@@ -20,7 +20,7 @@
  */
 /*
  * Copyright (c) 1990, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright 2016 Joyent, Inc.
+ * Copyright 2015 Joyent, Inc.
  */
 
 #include <sys/types.h>
@@ -43,7 +43,6 @@
 #include <sys/fs/tmpnode.h>
 #include <sys/ddi.h>
 #include <sys/sunddi.h>
-#include <vm/anon.h>
 
 #define	KILOBYTE	1024
 #define	MEGABYTE	(1024 * KILOBYTE)
@@ -55,80 +54,6 @@
 
 extern pgcnt_t swapfs_minfree;
 
-void *
-tmp_kmem_zalloc(struct tmount *tm, size_t size, int flag)
-{
-	void *buf;
-	zone_t *zone;
-	size_t pages;
-
-	mutex_enter(&tm->tm_contents);
-	zone = tm->tm_vfsp->vfs_zone;
-	if (tm->tm_anonmem + size > tm->tm_anonmax ||
-	    tm->tm_anonmem + size < tm->tm_anonmem ||
-	    size + ptob(tmpfs_minfree) <= size ||
-	    !anon_checkspace(size + ptob(tmpfs_minfree), zone)) {
-		mutex_exit(&tm->tm_contents);
-		return (NULL);
-	}
-
-	/*
-	 * Only make anonymous memory reservations when a page boundary is
-	 * crossed.  This is necessary since the anon_resv functions rounds up
-	 * to PAGESIZE internally.
-	 */
-	pages = btopr(tm->tm_allocmem + size);
-	pages -= btopr(tm->tm_allocmem);
-	if (pages > 0 && anon_try_resv_zone(ptob(pages), zone) == 0) {
-		mutex_exit(&tm->tm_contents);
-		return (NULL);
-	}
-
-	tm->tm_allocmem += size;
-	tm->tm_anonmem += size;
-	mutex_exit(&tm->tm_contents);
-
-	buf = kmem_zalloc(size, flag);
-	if (buf == NULL) {
-		mutex_enter(&tm->tm_contents);
-		ASSERT(tm->tm_anonmem > tm->tm_anonmem - size);
-		tm->tm_anonmem -= size;
-		if (pages > 0) {
-			/*
-			 * Re-chasing the zone pointer is necessary since a
-			 * forced umount could have been performed while the
-			 * tm_contents lock was dropped during allocation.
-			 */
-			anon_unresv_zone(ptob(pages), tm->tm_vfsp->vfs_zone);
-		}
-		mutex_exit(&tm->tm_contents);
-	}
-
-	return (buf);
-}
-
-void
-tmp_kmem_free(struct tmount *tm, void *buf, size_t size)
-{
-	size_t pages;
-
-	kmem_free(buf, size);
-	mutex_enter(&tm->tm_contents);
-	ASSERT(tm->tm_anonmem > tm->tm_anonmem - size);
-	tm->tm_anonmem -= size;
-	pages = btopr(tm->tm_allocmem);
-	tm->tm_allocmem -= size;
-	pages -= btopr(tm->tm_allocmem);
-	/*
-	 * Like the tmp_kmem_zalloc case, only unreserve anonymous memory when
-	 * a page boundary has been crossed.
-	 */
-	if (pages > 0) {
-		anon_unresv_zone(size, tm->tm_vfsp->vfs_zone);
-	}
-	mutex_exit(&tm->tm_contents);
-}
-
 int
 tmp_taccess(void *vtp, int mode, struct cred *cred)
 {
@@ -159,7 +84,7 @@
  */
 int
 tmp_sticky_remove_access(struct tmpnode *dir, struct tmpnode *entry,
-    struct cred *cr)
+	struct cred *cr)
 {
 	uid_t uid = crgetuid(cr);
 
@@ -174,8 +99,42 @@
 }
 
 /*
- * Convert a string containing a number (number of bytes) to a size_t,
- * containing the corresponding number of bytes. On 32-bit kernels, the
+ * Allocate zeroed memory if tmpfs_maxkmem has not been exceeded
+ * or the 'musthave' flag is set.  'musthave' allocations should
+ * always be subordinate to normal allocations so that tmpfs_maxkmem
+ * can't be exceeded by more than a few KB.  Example: when creating
+ * a new directory, the tmpnode is a normal allocation; if that
+ * succeeds, the dirents for "." and ".." are 'musthave' allocations.
+ */
+void *
+tmp_memalloc(size_t size, int musthave)
+{
+	static time_t last_warning;
+	time_t now;
+
+	if (atomic_add_long_nv(&tmp_kmemspace, size) < tmpfs_maxkmem ||
+	    musthave)
+		return (kmem_zalloc(size, KM_SLEEP));
+
+	atomic_add_long(&tmp_kmemspace, -size);
+	now = gethrestime_sec();
+	if (last_warning != now) {
+		last_warning = now;
+		cmn_err(CE_WARN, "tmp_memalloc: tmpfs over memory limit");
+	}
+	return (NULL);
+}
+
+void
+tmp_memfree(void *cp, size_t size)
+{
+	kmem_free(cp, size);
+	atomic_add_long(&tmp_kmemspace, -size);
+}
+
+/*
+ * Convert a string containing a number (number of bytes) to a pgcnt_t,
+ * containing the corresponding number of pages. On 32-bit kernels, the
  * maximum value encoded in 'str' is PAGESIZE * ULONG_MAX, while the value
  * returned in 'maxpg' is at most ULONG_MAX.
  *
@@ -193,12 +152,14 @@
  * error.
  */
 int
-tmp_convnum(char *str, size_t *maxbytes)
+tmp_convnum(char *str, pgcnt_t *maxpg)
 {
 	u_longlong_t num = 0;
-	u_longlong_t max_bytes = (uint64_t)SIZE_MAX;
-	size_t pages;
-
+#ifdef _LP64
+	u_longlong_t max_bytes = ULONG_MAX;
+#else
+	u_longlong_t max_bytes = PAGESIZE * (uint64_t)ULONG_MAX;
+#endif
 	char *c;
 	const struct convchar {
 		char *cc_char;
@@ -288,23 +249,14 @@
 	}
 
 done:
-
 	/*
-	 * We've been given a size in bytes; however, we want to make sure that
-	 * we have at least one page worth no matter what. Therefore we use
-	 * btopr to round up. However, this may cause an overflow only if 'num'
-	 * is between (max_bytes - PAGESIZE) and (max_bytes). In this case the
-	 * resulting number is zero, which is what we check for below. Note, we
-	 * require at least one page, so if pages is zero, well, it wasn't going
-	 * to work anyways.
+	 * Since btopr() rounds up to page granularity, this round-up can
+	 * cause an overflow only if 'num' is between (max_bytes - PAGESIZE)
+	 * and (max_bytes). In this case the resulting number is zero, which
+	 * is what we check for below.
 	 */
-	pages = btopr(num);
-	if (pages == 0) {
+	if ((*maxpg = (pgcnt_t)btopr(num)) == 0 && num != 0)
 		return (EINVAL);
-	}
-
-	*maxbytes = ptob(pages);
-
 	return (0);
 }
 
--- old/usr/src/uts/common/fs/tmpfs/tmp_vfsops.c	Wed Oct  5 00:33:44 2016
+++ new/usr/src/uts/common/fs/tmpfs/tmp_vfsops.c	Wed Oct  5 00:33:44 2016
@@ -20,7 +20,7 @@
  */
 /*
  * Copyright (c) 1990, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright 2016 Joyent, Inc.
+ * Copyright 2015 Joyent, Inc.
  */
 
 #include <sys/types.h>
@@ -56,15 +56,6 @@
 static int tmpfsfstype;
 
 /*
- * tmpfs_mountcount is used to prevent module unloads while there is still
- * state from a former mount hanging around. With forced umount support, the
- * filesystem module must not be allowed to go away before the last
- * VFS_FREEVFS() call has been made. Since this is just an atomic counter,
- * there's no need for locking.
- */
-static uint32_t	tmpfs_mountcount;
-
-/*
  * tmpfs vfs operations.
  */
 static int tmpfsinit(int, char *);
@@ -74,7 +65,6 @@
 static int tmp_root(struct vfs *, struct vnode **);
 static int tmp_statvfs(struct vfs *, struct statvfs64 *);
 static int tmp_vget(struct vfs *, struct vnode **, struct fid *);
-static void tmp_freevfs(vfs_t *vfsp);
 
 /*
  * Loadable module wrapper
@@ -133,14 +123,6 @@
 {
 	int error;
 
-	/*
-	 * If a forceably unmounted instance is still hanging around, we cannot
-	 * allow the module to be unloaded because that would cause panics once
-	 * the VFS framework decides it's time to call into VFS_FREEVFS().
-	 */
-	if (tmpfs_mountcount)
-		return (EBUSY);
-
 	error = mod_remove(&modlinkage);
 	if (error)
 		return (error);
@@ -159,6 +141,14 @@
 }
 
 /*
+ * The following are patchable variables limiting the amount of system
+ * resources tmpfs can use.
+ *
+ * tmpfs_maxkmem limits the amount of kernel kmem_alloc memory
+ * tmpfs can use for it's data structures (e.g. tmpnodes, directory entries)
+ * It is not determined by setting a hard limit but rather as a percentage of
+ * physical memory which is determined when tmpfs is first used in the system.
+ *
  * tmpfs_minfree is the minimum amount of swap space that tmpfs leaves for
  * the rest of the system.  In other words, if the amount of free swap space
  * in the system (i.e. anoninfo.ani_free) drops below tmpfs_minfree, tmpfs
@@ -167,7 +157,9 @@
  * There is also a per mount limit on the amount of swap space
  * (tmount.tm_anonmax) settable via a mount option.
  */
+size_t tmpfs_maxkmem = 0;
 size_t tmpfs_minfree = 0;
+size_t tmp_kmemspace;		/* bytes of kernel heap used by all tmpfs */
 
 static major_t tmpfs_major;
 static minor_t tmpfs_minor;
@@ -186,7 +178,6 @@
 		VFSNAME_ROOT,		{ .vfs_root = tmp_root },
 		VFSNAME_STATVFS,	{ .vfs_statvfs = tmp_statvfs },
 		VFSNAME_VGET,		{ .vfs_vget = tmp_vget },
-		VFSNAME_FREEVFS,	{ .vfs_freevfs = tmp_freevfs },
 		NULL,			NULL
 	};
 	int error;
@@ -221,12 +212,18 @@
 		tmpfs_minfree = btopr(TMPMINFREE);
 	}
 
+	/*
+	 * The maximum amount of space tmpfs can allocate is
+	 * TMPMAXPROCKMEM percent of kernel memory
+	 */
+	if (tmpfs_maxkmem == 0)
+		tmpfs_maxkmem = MAX(PAGESIZE, kmem_maxavail() / TMPMAXFRACKMEM);
+
 	if ((tmpfs_major = getudev()) == (major_t)-1) {
 		cmn_err(CE_WARN, "tmpfsinit: Can't get unique device number.");
 		tmpfs_major = 0;
 	}
 	mutex_init(&tmpfs_minor_lock, NULL, MUTEX_DEFAULT, NULL);
-	tmpfs_mountcount = 0;
 	return (0);
 }
 
@@ -237,7 +234,7 @@
 	struct tmpnode *tp;
 	struct pathname dpn;
 	int error;
-	size_t anonmax;
+	pgcnt_t anonmax;
 	struct vattr rattr;
 	int got_attrs;
 	boolean_t mode_arg = B_FALSE;
@@ -281,7 +278,7 @@
 		if ((error = tmp_convnum(argstr, &anonmax)) != 0)
 			goto out;
 	} else {
-		anonmax = SIZE_MAX;
+		anonmax = ULONG_MAX;
 	}
 
 	/*
@@ -314,8 +311,7 @@
 		goto out;
 	}
 
-	if ((tm = kmem_zalloc(sizeof (struct tmount),
-	    KM_NOSLEEP | KM_NORMALPRI)) == NULL) {
+	if ((tm = tmp_memalloc(sizeof (struct tmount), 0)) == NULL) {
 		pn_free(&dpn);
 		error = ENOMEM;
 		goto out;
@@ -347,20 +343,10 @@
 	vfsp->vfs_bsize = PAGESIZE;
 	vfsp->vfs_flag |= VFS_NOTRUNC;
 	vfs_make_fsid(&vfsp->vfs_fsid, tm->tm_dev, tmpfsfstype);
-	tm->tm_mntpath = kmem_zalloc(dpn.pn_pathlen + 1, KM_SLEEP);
+	tm->tm_mntpath = tmp_memalloc(dpn.pn_pathlen + 1, TMP_MUSTHAVE);
 	(void) strcpy(tm->tm_mntpath, dpn.pn_path);
 
 	/*
-	 * Preemptively set vfs_zone before any of the tmp_kmem_* functions are
-	 * called.  That field is not populated until after a successful
-	 * VFS_MOUNT when domount() sets vfsp metadata via vfs_add().  An
-	 * accurate value is required for proper swap usage accounting.
-	 */
-	ASSERT0(uap->flags & MS_REMOUNT);
-	ASSERT(vfsp->vfs_zone == NULL);
-	vfsp->vfs_zone = curproc->p_zone;
-
-	/*
 	 * allocate and initialize root tmpnode structure
 	 */
 	bzero(&rattr, sizeof (struct vattr));
@@ -367,17 +353,7 @@
 	rattr.va_mode = (mode_t)(S_IFDIR | root_mode);
 	rattr.va_type = VDIR;
 	rattr.va_rdev = 0;
-	tp = tmp_kmem_zalloc(tm, sizeof (struct tmpnode), KM_SLEEP);
-	if (tp == NULL) {
-		kmem_free(tm->tm_mntpath, strlen(tm->tm_mntpath) + 1);
-		mutex_destroy(&tm->tm_contents);
-		mutex_destroy(&tm->tm_renamelck);
-		kmem_free(tm, sizeof (struct tmount));
-
-		pn_free(&dpn);
-		error = ENOMEM;
-		goto out;
-	}
+	tp = tmp_memalloc(sizeof (struct tmpnode), TMP_MUSTHAVE);
 	tmpnode_init(tm, tp, &rattr, cr);
 
 	/*
@@ -416,34 +392,12 @@
 	tp->tn_nlink = 0;
 	tm->tm_rootnode = tp;
 
-	if (tdirinit(tp, tp) != 0) {
-		/*
-		 * While we would normally let our VOP_INACTIVE function take
-		 * care of cleaning up here, we're in a bit of a delicate
-		 * situation, so we do so manually. While it's tempting to try
-		 * and rely upon tmpfs_freevfs() and others, it's probably safer
-		 * for the time to do this manually at the cost of duplication.
-		 */
-		vn_invalid(TNTOV(tp));
-		rw_destroy(&tp->tn_rwlock);
-		mutex_destroy(&tp->tn_tlock);
-		vn_free(TNTOV(tp));
-		tmp_kmem_free(tm, tp, sizeof (struct tmpnode));
+	tdirinit(tp, tp);
 
-		kmem_free(tm->tm_mntpath, strlen(tm->tm_mntpath) + 1);
-		mutex_destroy(&tm->tm_contents);
-		mutex_destroy(&tm->tm_renamelck);
-		kmem_free(tm, sizeof (struct tmount));
-		pn_free(&dpn);
-		error = ENOMEM;
-		goto out;
-	}
-
 	rw_exit(&tp->tn_rwlock);
 
 	pn_free(&dpn);
 	error = 0;
-	atomic_inc_32(&tmpfs_mountcount);
 
 out:
 	if (error == 0)
@@ -459,107 +413,36 @@
 	struct tmpnode *tnp, *cancel;
 	struct vnode	*vp;
 	int error;
-	uint_t cnt;
-	int i;
 
 	if ((error = secpolicy_fs_unmount(cr, vfsp)) != 0)
 		return (error);
 
+	/*
+	 * forced unmount is not supported by this file system
+	 * and thus, ENOTSUP, is being returned.
+	 */
+	if (flag & MS_FORCE)
+		return (ENOTSUP);
+
 	mutex_enter(&tm->tm_contents);
 
 	/*
-	 * In the normal unmount case (non-forced unmount), if there are no
-	 * open files, only the root node should have a reference count.
-	 *
+	 * If there are no open files, only the root node should have
+	 * a reference count.
 	 * With tm_contents held, nothing can be added or removed.
 	 * There may be some dirty pages.  To prevent fsflush from
 	 * disrupting the unmount, put a hold on each node while scanning.
 	 * If we find a previously referenced node, undo the holds we have
 	 * placed and fail EBUSY.
-	 *
-	 * However, in the case of a forced umount, things are a bit different.
-	 * An additional VFS_HOLD is added for each outstanding VN_HOLD to
-	 * ensure that the file system is not cleaned up (tmp_freevfs) until
-	 * the last vfs hold is dropped. This happens in tmp_inactive as the
-	 * vnodes are released. Also, we can't add an additional VN_HOLD in
-	 * this case since that would prevent tmp_inactive from ever being
-	 * called. Finally, we do need to drop the zone ref now (zone_rele_ref)
-	 * so that the zone is not blocked waiting for the final file system
-	 * cleanup.
 	 */
 	tnp = tm->tm_rootnode;
-
-	vp = TNTOV(tnp);
-	mutex_enter(&vp->v_lock);
-	cnt = vp->v_count;
-	if (flag & MS_FORCE) {
-		vfsp->vfs_flag |= VFS_UNMOUNTED;
-		/* Extra hold which we rele below when we drop the zone ref */
-		VFS_HOLD(vfsp);
-
-		for (i = 1; i < cnt; i++)
-			VFS_HOLD(vfsp);
-
-		/* drop the mutex now because no one can find this mount */
+	if (TNTOV(tnp)->v_count > 1) {
 		mutex_exit(&tm->tm_contents);
-	} else if (cnt > 1) {
-		mutex_exit(&vp->v_lock);
-		mutex_exit(&tm->tm_contents);
 		return (EBUSY);
 	}
-	mutex_exit(&vp->v_lock);
 
-	/*
-	 * Check for open files. An open file causes everything to unwind
-	 * unless this is a forced umount.
-	 */
 	for (tnp = tnp->tn_forw; tnp; tnp = tnp->tn_forw) {
-		vp = TNTOV(tnp);
-		mutex_enter(&vp->v_lock);
-		cnt = vp->v_count;
-		if (flag & MS_FORCE) {
-			for (i = 0; i < cnt; i++)
-				VFS_HOLD(vfsp);
-
-			/*
-			 * In the case of a forced umount don't add an
-			 * additional VN_HOLD on the already held vnodes, like
-			 * we do in the non-forced unmount case. If the
-			 * cnt > 0, then the vnode already has at least one
-			 * hold and we need tmp_inactive to get called when the
-			 * last pre-existing hold on the node is released so
-			 * that we can VFS_RELE the VFS holds we just added.
-			 */
-			if (cnt == 0) {
-				/* directly add VN_HOLD since have the lock */
-				vp->v_count++;
-			}
-
-			mutex_exit(&vp->v_lock);
-
-			/*
-			 * If the tmpnode has any pages associated with it
-			 * (i.e. if it's a normal file with non-zero size), the
-			 * tmpnode could still be discovered by pageout or
-			 * fsflush via the page vnode pointers. To prevent this
-			 * from interfering with the tmp_freevfs, truncate the
-			 * tmpnode now.
-			 */
-			if (tnp->tn_size != 0 && tnp->tn_type == VREG) {
-				rw_enter(&tnp->tn_rwlock, RW_WRITER);
-				rw_enter(&tnp->tn_contents, RW_WRITER);
-
-				(void) tmpnode_trunc(tm, tnp, 0);
-
-				rw_exit(&tnp->tn_contents);
-				rw_exit(&tnp->tn_rwlock);
-
-				ASSERT(tnp->tn_size == 0);
-				ASSERT(tnp->tn_nblocks == 0);
-			}
-		} else if (cnt > 0) {
-			/* An open file; unwind the holds we've been adding. */
-			mutex_exit(&vp->v_lock);
+		if ((vp = TNTOV(tnp))->v_count > 0) {
 			cancel = tm->tm_rootnode->tn_forw;
 			while (cancel != tnp) {
 				vp = TNTOV(cancel);
@@ -569,51 +452,15 @@
 			}
 			mutex_exit(&tm->tm_contents);
 			return (EBUSY);
-		} else {
-			/* directly add a VN_HOLD since we have the lock */
-			vp->v_count++;
-			mutex_exit(&vp->v_lock);
 		}
+		VN_HOLD(vp);
 	}
 
-	if (flag & MS_FORCE) {
-		/*
-		 * Drop the zone ref now since we don't know how long it will
-		 * be until the final vfs_rele is called by tmp_inactive.
-		 */
-		if (vfsp->vfs_zone) {
-			zone_rele_ref(&vfsp->vfs_implp->vi_zone_ref,
-			    ZONE_REF_VFS);
-			vfsp->vfs_zone = 0;
-		}
-		/* We can now drop the extra hold we added above. */
-		VFS_RELE(vfsp);
-	} else {
-		/*
-		 * For the non-forced case, we can drop the mutex now because
-		 * no one can find this mount anymore
-		 */
-		vfsp->vfs_flag |= VFS_UNMOUNTED;
-		mutex_exit(&tm->tm_contents);
-	}
+	/*
+	 * We can drop the mutex now because no one can find this mount
+	 */
+	mutex_exit(&tm->tm_contents);
 
-	return (0);
-}
-
-/*
- * Implementation of VFS_FREEVFS() to support forced umounts. This is called by
- * the vfs framework after umount and the last VFS_RELE, to trigger the release
- * of any resources still associated with the given vfs_t. We only add
- * additional VFS_HOLDs during the forced umount case, so this is normally
- * called immediately after tmp_umount.
- */
-void
-tmp_freevfs(vfs_t *vfsp)
-{
-	struct tmount *tm = (struct tmount *)VFSTOTM(vfsp);
-	struct tmpnode *tnp;
-	struct vnode	*vp;
-
 	/*
 	 * Free all kmemalloc'd and anonalloc'd memory associated with
 	 * this filesystem.  To do this, we go through the file list twice,
@@ -622,17 +469,7 @@
 	 * tmpnode_free which assumes that the directory entry has been
 	 * removed before the file.
 	 */
-
 	/*
-	 * Now that we are tearing ourselves down we need to remove the
-	 * UNMOUNTED flag. If we don't, we'll later hit a VN_RELE when we remove
-	 * files from the system causing us to have a negative value. Doing this
-	 * seems a bit better than trying to set a flag on the tmount that says
-	 * we're tearing down.
-	 */
-	vfsp->vfs_flag &= ~VFS_UNMOUNTED;
-
-	/*
 	 * Remove all directory entries
 	 */
 	for (tnp = tm->tm_rootnode; tnp; tnp = tnp->tn_forw) {
@@ -698,16 +535,15 @@
 
 	ASSERT(tm->tm_mntpath);
 
-	kmem_free(tm->tm_mntpath, strlen(tm->tm_mntpath) + 1);
+	tmp_memfree(tm->tm_mntpath, strlen(tm->tm_mntpath) + 1);
 
 	ASSERT(tm->tm_anonmem == 0);
 
 	mutex_destroy(&tm->tm_contents);
 	mutex_destroy(&tm->tm_renamelck);
-	kmem_free(tm, sizeof (struct tmount));
+	tmp_memfree(tm, sizeof (struct tmount));
 
-	/* Allow _fini() to succeed now */
-	atomic_dec_32(&tmpfs_mountcount);
+	return (0);
 }
 
 /*
@@ -769,12 +605,11 @@
 	 * If tm_anonmax for this mount is less than the available swap space
 	 * (minus the amount tmpfs can't use), use that instead
 	 */
-	if (blocks > tmpfs_minfree && tm->tm_anonmax > tm->tm_anonmem) {
+	if (blocks > tmpfs_minfree)
 		sbp->f_bfree = MIN(blocks - tmpfs_minfree,
-		    btop(tm->tm_anonmax) - btopr(tm->tm_anonmem));
-	} else {
+		    tm->tm_anonmax - tm->tm_anonmem);
+	else
 		sbp->f_bfree = 0;
-	}
 
 	sbp->f_bavail = sbp->f_bfree;
 
@@ -781,7 +616,7 @@
 	/*
 	 * Total number of blocks is what's available plus what's been used
 	 */
-	sbp->f_blocks = (fsblkcnt64_t)(sbp->f_bfree + btopr(tm->tm_anonmem));
+	sbp->f_blocks = (fsblkcnt64_t)(sbp->f_bfree + tm->tm_anonmem);
 
 	if (eff_zid != GLOBAL_ZONEUNIQID &&
 	    zp->zone_max_swap_ctl != UINT64_MAX) {
@@ -811,7 +646,13 @@
 	 * available to tmpfs.  This is fairly inaccurate since it doesn't
 	 * take into account the names stored in the directory entries.
 	 */
-	sbp->f_ffree = sbp->f_files = ptob(availrmem) /
+	if (tmpfs_maxkmem > tmp_kmemspace)
+		sbp->f_ffree = (tmpfs_maxkmem - tmp_kmemspace) /
+		    (sizeof (struct tmpnode) + sizeof (struct tdirent));
+	else
+		sbp->f_ffree = 0;
+
+	sbp->f_files = tmpfs_maxkmem /
 	    (sizeof (struct tmpnode) + sizeof (struct tdirent));
 	sbp->f_favail = (fsfilcnt64_t)(sbp->f_ffree);
 	(void) cmpldev(&d32, vfsp->vfs_dev);
--- old/usr/src/uts/common/fs/tmpfs/tmp_vnops.c	Wed Oct  5 00:33:44 2016
+++ new/usr/src/uts/common/fs/tmpfs/tmp_vnops.c	Wed Oct  5 00:33:44 2016
@@ -25,7 +25,7 @@
  */
 
 /*
- * Copyright 2016 Joyent, Inc.
+ * Copyright 2016, Joyent, Inc.
  * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
  * Copyright 2016 RackTop Systems.
  */
@@ -585,10 +585,6 @@
 	struct tmount *tm = (struct tmount *)VTOTM(vp);
 	int error;
 
-	/* If the filesystem was umounted by force, return immediately. */
-	if (vp->v_vfsp->vfs_flag & VFS_UNMOUNTED)
-		return (EIO);
-
 	/*
 	 * We don't currently support reading non-regular files
 	 */
@@ -618,10 +614,6 @@
 	struct tmount *tm = (struct tmount *)VTOTM(vp);
 	int error;
 
-	/* If the filesystem was umounted by force, return immediately. */
-	if (vp->v_vfsp->vfs_flag & VFS_UNMOUNTED)
-		return (EIO);
-
 	/*
 	 * We don't currently support writing to non-regular files
 	 */
@@ -847,9 +839,6 @@
 	struct tmpnode *ntp = NULL;
 	int error;
 
-	/* If the filesystem was umounted by force, return immediately. */
-	if (dvp->v_vfsp->vfs_flag & VFS_UNMOUNTED)
-		return (EIO);
 
 	/* allow cd into @ dir */
 	if (flags & LOOKUP_XATTR) {
@@ -868,8 +857,6 @@
 
 		rw_enter(&tp->tn_rwlock, RW_WRITER);
 		if (tp->tn_xattrdp == NULL) {
-			int err;
-
 			if (!(flags & CREATE_XATTR_DIR)) {
 				rw_exit(&tp->tn_rwlock);
 				return (ENOENT);
@@ -890,13 +877,9 @@
 				return (error);
 			}
 
+			xdp = tmp_memalloc(sizeof (struct tmpnode),
+			    TMP_MUSTHAVE);
 			tm = VTOTM(dvp);
-			xdp = tmp_kmem_zalloc(tm, sizeof (struct tmpnode),
-			    KM_SLEEP);
-			if (xdp == NULL) {
-				rw_exit(&tp->tn_rwlock);
-				return (ENOSPC);
-			}
 			tmpnode_init(tm, xdp, &tp->tn_attr, NULL);
 			/*
 			 * Fix-up fields unique to attribute directories.
@@ -914,16 +897,7 @@
 			}
 			xdp->tn_vnode->v_type = VDIR;
 			xdp->tn_vnode->v_flag |= V_XATTRDIR;
-			if ((err = tdirinit(tp, xdp)) != 0) {
-				rw_exit(&tp->tn_rwlock);
-				/*
-				 * This never got properly initialized so we can
-				 * just clean it up.
-				 */
-				xdp->tn_vnode->v_flag &= V_XATTRDIR;
-				tmpnode_cleanup(tp);
-				return (err);
-			}
+			tdirinit(tp, xdp);
 			tp->tn_xattrdp = xdp;
 		} else {
 			VN_HOLD(tp->tn_xattrdp->tn_vnode);
@@ -1505,10 +1479,6 @@
 	int reclen;
 	caddr_t outbuf;
 
-	/* If the filesystem was umounted by force, return immediately. */
-	if (vp->v_vfsp->vfs_flag & VFS_UNMOUNTED)
-		return (EIO);
-
 	if (uiop->uio_loffset >= MAXOFF_T) {
 		if (eofp)
 			*eofp = 1;
@@ -1642,12 +1612,12 @@
 	rw_exit(&parent->tn_rwlock);
 
 	if (error) {
-		if (self != NULL)
+		if (self)
 			tmpnode_rele(self);
 		return (error);
 	}
 	len = strlen(tnm) + 1;
-	cp = tmp_kmem_zalloc(tm, len, KM_NOSLEEP | KM_NORMALPRI);
+	cp = tmp_memalloc(len, 0);
 	if (cp == NULL) {
 		tmpnode_rele(self);
 		return (ENOSPC);
@@ -1712,27 +1682,10 @@
 	 * there's little to do -- just drop our hold.
 	 */
 	if (vp->v_count > 1 || tp->tn_nlink != 0) {
-		if (vp->v_vfsp->vfs_flag & VFS_UNMOUNTED) {
-			/*
-			 * Since the file system was forcibly unmounted, we can
-			 * have a case (v_count == 1, tn_nlink != 0) where this
-			 * file was open so we didn't add an extra hold on the
-			 * file in tmp_unmount. We are counting on the
-			 * interaction of the hold made in tmp_unmount and
-			 * rele-ed in tmp_vfsfree so we need to be sure we
-			 * don't decrement in this case.
-			 */
-			if (vp->v_count > 1)
-				vp->v_count--;
-		} else {
-			vp->v_count--;
-		}
+		vp->v_count--;
 		mutex_exit(&vp->v_lock);
 		mutex_exit(&tp->tn_tlock);
 		rw_exit(&tp->tn_rwlock);
-		/* If the filesystem was umounted by force, rele the vfs ref */
-		if (tm->tm_vfsp->vfs_flag & VFS_UNMOUNTED)
-			VFS_RELE(tm->tm_vfsp);
 		return;
 	}
 
@@ -1757,7 +1710,7 @@
 			goto top;
 		}
 		if (tp->tn_type == VLNK)
-			tmp_kmem_free(tm, tp->tn_symlink, tp->tn_size + 1);
+			tmp_memfree(tp->tn_symlink, tp->tn_size + 1);
 	}
 
 	/*
@@ -1791,11 +1744,7 @@
 	rw_destroy(&tp->tn_rwlock);
 	mutex_destroy(&tp->tn_tlock);
 	vn_free(TNTOV(tp));
-	tmp_kmem_free(tm, tp, sizeof (struct tmpnode));
-
-	/* If the filesystem was umounted by force, rele the vfs ref */
-	if (tm->tm_vfsp->vfs_flag & VFS_UNMOUNTED)
-		VFS_RELE(tm->tm_vfsp);
+	tmp_memfree(tp, sizeof (struct tmpnode));
 }
 
 /* ARGSUSED2 */
@@ -1917,10 +1866,6 @@
 	struct vnode *pvp;
 	u_offset_t poff;
 
-	/* If the filesystem was umounted by force, return immediately. */
-	if (vp->v_vfsp->vfs_flag & VFS_UNMOUNTED)
-		return (EIO);
-
 	if (protp != NULL)
 		*protp = PROT_ALL;
 again:
@@ -2142,10 +2087,6 @@
 	u_offset_t offset;
 	u_offset_t tmpoff;
 
-	/* If the filesystem was umounted by force, return immediately. */
-	if (vp->v_vfsp->vfs_flag & VFS_UNMOUNTED)
-		return (EIO);
-
 	ASSERT(PAGE_LOCKED(pp));
 
 	/* Kluster in tmp_klustsize chunks */
No differences encountered
No differences encountered
No differences encountered
